#! /usr/bin/perl -wT

unless (@ARGV == 5) { die "Usage: $0 file firstChunk secondOffset thirdOffset lastChunk\n" }
($sourcefile, $length, $offset, $offset2, $lastChunk) = @ARGV;

unless (open SOURCE, "<", $sourcefile) {
  die "Couldn't open source file $sourcefile: $!; aborting";
}

my $buffer;
my $pos = 0;
seek(SOURCE, $pos, 0);

print ("Extracting sample of $sourcefile -- Optimal size $length -- Last chunk at $offset2, length $lastChunk\n");

if(open(NEW, ">extract")){
	if (read(SOURCE, $buffer, $length)) { 
		# print each kb to the new file on the server 
		print NEW $buffer;
		seek(SOURCE, $offset, 0);
		if (read(SOURCE, $buffer, $length/2)) {
			print NEW $buffer;
			seek(SOURCE, $offset2, 0);
			if (read(SOURCE, $buffer, $lastChunk)) {
				print NEW $buffer;
			}
		}
	}
	# close the new file on the server and we're done
close NEW;
}

close SOURCE;
